Summary: A collection of basic system utilities.
Name: util-linux
Version: 2.10c
Release: 1
Copyright: distributable
Group: System Environment/Base
Source0: ftp://sunsite.unc.edu/pub/Linux/system/Misc/util-linux-%{version}.tar.gz
Source1: util-linux-2.7-login.pamd
Source2: util-linux-2.7-chfn.pamd
Source3: util-linux-2.7-chsh.pamd
Source4: util-linux-2.9w-kbdrate.pamd
Source5: util-linux-2.9w-kbdrate.apps

Patch0: util-linux-2.10c-rhconfig.patch
Patch1: util-linux-2.9w-nochkdupexe.patch
Patch2: util-linux-2.7-gecos.patch
# XXX apply next patch to enable mount-2.8 from util-linux (not applied)
Patch4: util-linux-2.9i-mount.patch
Patch6: util-linux-2.9i-fdiskwarning.patch
Patch8: util-linux-2.9i-nomount.patch
Patch11: util-linux-2.9o-btmp.patch
Patch13: util-linux-2.9o-openlog.patch
Patch16: util-linux-2.9o-mkswap2.patch
Patch21: util-linux-2.9v-nonroot.patch
Patch23: util-linux-2.9w-kbdrate.patch

Obsoletes: fdisk tunelp
%ifarch sparc alpha
Obsoletes: clock
%endif
%ifarch alpha
Conflicts: initscripts <= 4.58, timeconfig <= 3.0.1
%endif
BuildRoot: /var/tmp/%{name}-root
Requires: pam >= 0.66-4, kernel >= 2.2.12-7


%description
The util-linux package contains a large variety of low-level system
utilities that are necessary for a Linux system to function.  Among
many features, Util-linux contains the fdisk configuration tool and
login program.

%prep

%setup -q

%patch0 -p1 -b .rhconfig
%patch1 -p1 -b .nochkdupexe
%patch2 -p1 -b .gecos

# mount comes from it's own rpm (again)
#%patch4 -p1 -b .mount

%patch6 -p1 -b .fdiskwarning
%patch8 -p1 -b .nomount
%patch11 -p1 -b .btmp
%patch13 -p1 -b .openlog
%patch16 -p1 -b .mkswap2
%patch21 -p1 -b .nonroot
%patch23 -p1 -b .kbdrate

%build
unset LINGUAS || :
./configure
make "RPM_OPT_FLAGS=$RPM_OPT_FLAGS" 

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/{bin,etc/pam.d,sbin}
mkdir -p $RPM_BUILD_ROOT/usr/{bin,info,lib,man/man1,man/man6,man/man8,sbin}
mkdir -p $RPM_BUILD_ROOT/usr/share/locale/{cs,de,fr,it,ja,nl,pt_BR}/LC_MESSAGES
mkdir -p $RPM_BUILD_ROOT/etc/security/console.apps

make install DESTDIR=$RPM_BUILD_ROOT

%ifarch sparc
rm -rf $RPM_BUILD_ROOT/usr/bin/sunhostid
cat << E-O-F > $RPM_BUILD_ROOT/usr/bin/sunhostid
#!/bin/sh
# this should be /usr/bin/sunhostid or somesuch.
# Copyright 1999 Peter Jones, <pjones@redhat.com> .  
# GPL and all that good stuff apply.
(
idprom=\`cat /proc/openprom/idprom\`
echo \$idprom|dd bs=1 skip=2 count=2
echo \$idprom|dd bs=1 skip=27 count=6
echo
) 2>/dev/null
E-O-F
chmod 755 $RPM_BUILD_ROOT/usr/bin/sunhostid
%endif

gzip -9nf $RPM_BUILD_ROOT/usr/info/ipc.info

for i in /bin/login /usr/bin/chfn /usr/bin/chsh /usr/bin/newgrp ; do
	strip $RPM_BUILD_ROOT/$i
done

strip $RPM_BUILD_ROOT/sbin/fdisk || :

install -m 644 ${RPM_SOURCE_DIR}/util-linux-2.7-login.pamd $RPM_BUILD_ROOT/etc/pam.d/login
install -m 644 ${RPM_SOURCE_DIR}/util-linux-2.7-chsh.pamd $RPM_BUILD_ROOT/etc/pam.d/chsh
install -m 644 ${RPM_SOURCE_DIR}/util-linux-2.7-chsh.pamd $RPM_BUILD_ROOT/etc/pam.d/chfn
install -m 644 ${RPM_SOURCE_DIR}/util-linux-2.9w-kbdrate.pamd $RPM_BUILD_ROOT/etc/pam.d/kbdrate
install -m 644 ${RPM_SOURCE_DIR}/util-linux-2.9w-kbdrate.apps $RPM_BUILD_ROOT/etc/security/console.apps/kbdrate
(cd $RPM_BUILD_ROOT/usr/bin ; ln -s consolehelper kbdrate)

rm -f $RPM_BUILD_ROOT/sbin/clock
ln -s hwclock $RPM_BUILD_ROOT/sbin/clock

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/usr/share/locale/*/LC_MESSAGES/*

/sbin/clock
/sbin/hwclock
/usr/man/man8/hwclock.8

/usr/sbin/tunelp
/usr/man/man8/tunelp.8

%config /etc/pam.d/login
%config /etc/pam.d/chfn
%config /etc/pam.d/chsh

%config /etc/pam.d/kbdrate
%config /etc/security/console.apps/kbdrate
/usr/bin/kbdrate

/sbin/fdisk
%ifarch i386 alpha armv4l
/sbin/cfdisk
%endif

%ifarch i386 alpha
/sbin/fsck.minix
/sbin/mkfs.minix
%endif

/usr/bin/raw
/usr/man/man8/raw.8

/sbin/mkfs
/sbin/mkswap

/usr/bin/fdformat
/usr/bin/setfdprm
%config /etc/fdprm

/usr/man/man8/fdformat.8
/usr/man/man8/mkswap.8
/usr/man/man8/setfdprm.8

/usr/games/banner
/usr/man/man6/banner.6

/usr/bin/ddate
/usr/man/man1/ddate.1

%ifarch i386 alpha sparc
%attr(755,root,root)	/bin/login
%attr(4711,root,root)	/usr/bin/chfn
%attr(4711,root,root)	/usr/bin/chsh
%attr(4711,root,root)	/usr/bin/newgrp
/usr/sbin/vipw
/usr/sbin/vigr
/usr/man/man1/chfn.1
/usr/man/man1/chsh.1
/usr/man/man1/login.1
/usr/man/man1/newgrp.1
/usr/man/man8/vipw.8
/usr/man/man8/vigr.8
%endif

/bin/kill
/usr/bin/cal
%ifarch sparc
/usr/bin/sunhostid
%endif
/usr/bin/logger
/usr/bin/look
/usr/bin/mcookie
/usr/bin/namei
/usr/bin/script
/usr/bin/setterm
#/usr/bin/tsort
/usr/bin/whereis
%attr(2755,root,tty)	/usr/bin/write
/usr/bin/getopt
/usr/man/man1/cal.1
#/usr/man/man1/hostid.1
/usr/man/man1/kill.1
/usr/man/man1/logger.1
/usr/man/man1/look.1
/usr/man/man1/mcookie.1
/usr/man/man1/namei.1
/usr/man/man1/script.1
/usr/man/man1/setterm.1
#/usr/man/man1/tsort.1
/usr/man/man1/whereis.1
/usr/man/man1/write.1
/usr/man/man1/getopt.1

/usr/lib/getopt

/bin/dmesg

/sbin/ctrlaltdel
/sbin/kbdrate
#/sbin/sln
/bin/arch
/usr/bin/ipcrm
/usr/bin/ipcs
/usr/bin/renice
/usr/sbin/readprofile
/usr/bin/setsid
%ifarch i386 alpha armv4l
/usr/bin/cytune
%endif

/usr/man/man1/arch.1
/usr/man/man1/readprofile.1
/usr/man/man8/cytune.8
/usr/man/man8/ctrlaltdel.8
/usr/man/man8/dmesg.8
/usr/man/man8/ipcrm.8
/usr/man/man8/ipcs.8
/usr/man/man8/kbdrate.8
/usr/man/man8/renice.8
/usr/man/man8/setsid.8

%ifarch i386
/usr/sbin/rdev
/usr/sbin/ramsize
/usr/sbin/rootflags
/usr/sbin/swapdev
/usr/sbin/vidmode
/usr/man/man8/rdev.8
/usr/man/man8/ramsize.8
/usr/man/man8/rootflags.8
/usr/man/man8/swapdev.8
/usr/man/man8/vidmode.8
%endif

/usr/info/ipc.info.gz

/usr/bin/col
/usr/bin/colcrt
/usr/bin/colrm
/usr/bin/column
/usr/bin/hexdump
/usr/bin/rev
/usr/bin/ul

/usr/man/man1/col.1
/usr/man/man1/colcrt.1
/usr/man/man1/colrm.1
/usr/man/man1/column.1
/usr/man/man1/hexdump.1
/usr/man/man1/rev.1
/usr/man/man1/ul.1
/bin/more
/usr/man/man1/more.1
/usr/lib/more.help

%ifarch i386 alpha
/usr/man/man8/fsck.minix.8
/usr/man/man8/mkfs.minix.8
/usr/man/man8/mkfs.8
%endif

/usr/man/man8/fdisk.8

%ifarch i386 alpha armv4l
/usr/man/man8/cfdisk.8
%endif

%doc */README.*

%ifarch i386 alpha
/sbin/sfdisk
/usr/man/man8/sfdisk.8
%doc fdisk/sfdisk.examples
%endif

%changelog
* Tue Dec  7 1999 Matt Wilson <msw@redhat.com>
- updated to util-linux 2.10c
- deprecated IMAP login mail notification patch17
- deprecated raw patch22
- depricated readprofile patch24

* Tue Dec  7 1999 Bill Nottingham <notting@redhat.com>
- add patch for readprofile

* Thu Nov 18 1999 Michael K. Johnson <johnsonm@redhat.com>
- tunelp should come from util-linux

* Tue Nov  9 1999 Jakub Jelinek <jakub@redhat.com>
- kbdrate cannot use /dev/port on sparc.

* Wed Nov  3 1999 Jakub Jelinek <jakub@redhat.com>
- fix kbdrate on sparc.

* Wed Oct 27 1999 Bill Nottingham <notting@redhat.com>
- ship hwclock on alpha.

* Tue Oct  5 1999 Bill Nottingham <notting@redhat.com>
- don't ship symlinks to rdev if we don't ship rdev.

* Tue Sep 07 1999 Cristian Gafton <gafton@redhat.com>
- add rawIO support from sct

* Mon Aug 30 1999 Preston Brown <pbrown@redhat.com>
- don't display "new mail" message when the only piece of mail is from IMAP

* Fri Aug 27 1999 Michael K. Johnson <johnsonm@redhat.com>
- kbdrate is now a console program

* Thu Aug 26 1999 Jeff Johnson <jbj@redhat.com>
- hostid is now in sh-utils. On sparc, install hostid as sunhostid (#4581).
- update to 2.9w:
-  Updated mount.8 (Yann Droneaud)
-  Improved makefiles
-  Fixed flaw in fdisk

* Tue Aug 10 1999 Jeff Johnson <jbj@redhat.com>
- tsort is now in textutils.

* Wed Aug  4 1999 Bill Nottingham <notting@redhat.com>
- turn off setuid bit on login. Again. :(

* Tue Aug  3 1999 Peter Jones, <pjones@redhat.com>
- hostid script for sparc (#3803).

* Tue Aug 03 1999 Christian 'Dr. Disk' Hechelmann <drdisk@tc-gruppe.de>
- added locale message catalogs to %file
- added patch for non-root build
- vigr.8 and /usr/lib/getopt  man-page was missing from file list
- /etc/fdprm really is a config file

* Fri Jul 23 1999 Jeff Johnson <jbj@redhat.com>
- update to 2.9v:
-   cfdisk no longer believes the kernel's HDGETGEO
    (and may be able to partition a 2 TB disk)

* Fri Jul 16 1999 Jeff Johnson <jbj@redhat.com>
- update to 2.9u:
-   Czech more.help and messages (Ji Pavlovsk)
-   Japanese messages (Daisuke Yamashita)
-   fdisk fix (Klaus G. Wagner)
-   mount fix (Hirokazu Takahashi)
-   agetty: enable hardware flow control (Thorsten Kranzkowski)
-   minor cfdisk improvements
-   fdisk no longer accepts a default device
-   Makefile fix

* Tue Jul  6 1999 Jeff Johnson <jbj@redhat.com>
- update to 2.9t:
-   national language support for hwclock
-   Japanese messages (both by Daisuke Yamashita)
-   German messages and some misc i18n fixes (Elrond)
-   Czech messages (Ji Pavlovsk)
-   wall fixed for /dev/pts/xx ttys
-   make last and wall use getutent() (Sascha Schumann)
    [Maybe this is bad: last reading all of wtmp may be too slow.
     Revert in case people complain.]
-   documented UUID= and LABEL= in fstab.5
-   added some partition types
-   swapon: warn only if verbose

* Fri Jun 25 1999 Jeff Johnson <jbj@redhat.com>
- update to 2.9s.

* Sat May 29 1999 Jeff Johnson <jbj@redhat.com>
- fix mkswap sets incorrect bits on sparc64 (#3140).

* Thu Apr 15 1999 Jeff Johnson <jbj@redhat.com>
- on sparc64 random ioctls on clock interface cause kernel messages.

* Thu Apr 15 1999 Jeff Johnson <jbj@redhat.com>
- improved raid patch (H.J. Lu).

* Wed Apr 14 1999 Michael K. Johnson <johnsonm@redhat.com>
- added patch for smartraid controllers

* Sat Apr 10 1999 Cristian Gafton <gafton@redhat.com>
- fix logging problems caused by setproctitle and PAM interaction
  (#2045)

* Wed Mar 31 1999 Jeff Johnson <jbj@redhat.com>
- include docs and examples for sfdisk (#1164)

* Mon Mar 29 1999 Matt Wilson <msw@redhat.com>
- rtc is not working properly on alpha, we can't use hwclock yet.

* Fri Mar 26 1999 Cristian Gafton <gafton@redhat.com>
- add patch to make mkswap more 64 bit friendly... Patch from
  eranian@hpl.hp.com (ahem!)

* Thu Mar 25 1999 Jeff Johnson <jbj@redhat.com>
- include sfdisk (#1164)
- fix write (#1784)
- use positive logic in spec file (%ifarch rather than %ifnarch).
- (re)-use 1st matching utmp slot if search by mypid not found.
- update to 2.9o
- lastb wants bad logins in wtmp clone /var/run/btmp (#884)

* Thu Mar 25 1999 Jakub Jelinek <jj@ultra.linux.cz>
- if hwclock is to be compiled on sparc,
  it must actually work. Also, it should obsolete
  clock, otherwise it clashes.
- limit the swap size in mkswap for 2.2.1+ kernels
  by the actual maximum size kernel can handle.
- fix kbdrate on sparc, patch by J. S. Connell
  <ankh@canuck.gen.nz>

* Wed Mar 24 1999 Matt Wilson <msw@redhat.com>
- added pam_console back into pam.d/login

* Tue Mar 23 1999 Matt Wilson <msw@redhat.com>
- updated to 2.9i
- added hwclock for sparcs and alpha

* Mon Mar 22 1999 Erik Troan <ewt@redhat.com>
- added vigr to file list

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 12)

* Thu Mar 18 1999 Cristian Gafton <gafton@redhat.com>
- remove most of the ifnarch arm stuff

* Mon Mar 15 1999 Michael Johnson <johnsonm@redhat.com>
- added pam_console.so to /etc/pam.d/login

* Thu Feb  4 1999 Michael K. Johnson <johnsonm@redhat.com>
- .perms patch to login to make it retain root in parent process
  for pam_close_session to work correctly

* Tue Jan 12 1999 Jeff Johnson <jbj@redhat.com>
- strip fdisk in buildroot correctly (#718)

* Mon Jan 11 1999 Cristian Gafton <gafton@redhat.com>
- have fdisk compiled on sparc and arm

* Mon Jan 11 1999 Erik Troan <ewt@redhat.com>
- added beos partition type to fdisk

* Wed Dec 30 1998 Cristian Gafton <gafton@redhat.com>
- incorporate fdisk on all arches

* Sat Dec  5 1998 Jeff Johnson <jbj@redhat.com>
- restore PAM functionality at end of login (Bug #201)

* Thu Dec 03 1998 Cristian Gafton <gafton@redhat.com>
- patch top build on the arm without PAM and related utilities, for now.
- build hwclock only on intel

* Wed Nov 18 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to version 2.9

* Thu Oct 29 1998 Bill Nottingham <notting@redhat.com>
- build for Raw Hide (slang-1.2.2)
- patch kbdrate wackiness so it builds with egcs

* Tue Oct 13 1998 Erik Troan <ewt@redhat.com>
- patched more to use termcap

* Mon Oct 12 1998 Erik Troan <ewt@redhat.com>
- added warning about alpha/bsd label starting cylinder

* Mon Sep 21 1998 Erik Troan <ewt@redhat.com>
- use sigsetjmp/siglongjmp in more rather then sig'less versions

* Fri Sep 11 1998 Jeff Johnson <jbj@redhat.com>
- explicit attrs for setuid/setgid programs

* Thu Aug 27 1998 Cristian Gafton <gafton@redhat.com>
- sln is now included in glibc

* Sun Aug 23 1998 Jeff Johnson <jbj@redhat.com>
- add cbm1581 floppy definitions (problem #787)

* Mon Jun 29 1998 Jeff Johnson <jbj@redhat.com>
- remove /etc/nologin at end of shutdown/halt.

* Fri Jun 19 1998 Jeff Johnson <jbj@redhat.com>
- add mount/losetup.

* Thu Jun 18 1998 Jeff Johnson <jbj@redhat.com>
- update to 2.8 with 2.8b clean up. hostid now defunct?

* Mon Jun 01 1998 David S. Miller <davem@dm.cobaltmicro.com>
- "more" now works properly on sparc

* Sat May 02 1998 Jeff Johnson <jbj@redhat.com>
- Fix "fdisk -l" fault on mounted cdrom. (prob #513)

* Fri Apr 24 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Sat Apr 11 1998 Cristian Gafton <gafton@redhat.com>
- manhattan rebuild

* Mon Dec 29 1997 Erik Troan <ewt@redhat.com>
- more didn't suspend properly on glibc
- use proper tc*() calls rather then ioctl's

* Sun Dec 21 1997 Cristian Gafton <gafton@redhat.com>
- fixed a security problem in chfn and chsh accepting too 
  long gecos fields

* Fri Dec 19 1997 Mike Wangsmo <wanger@redhat.com>
- removed "." from default path

* Tue Dec 02 1997 Cristian Gafton <gafton@redhat.com>
- added (again) the vipw patch

* Wed Oct 22 1997 Michael Fulbright <msf@redhat.com>
- minor cleanups for glibc 2.1

* Fri Oct 17 1997 Michael Fulbright <msf@redhat.com>
- added vfat32 filesystem type to list recognized by fdisk

* Fri Oct 10 1997 Erik Troan <ewt@redhat.com>
- don't build clock on the alpha 
- don't install chkdupexe

* Thu Oct 02 1997 Michael K. Johnson <johnsonm@redhat.com>
- Update to new pam standard.
- BuildRoot.

* Thu Sep 25 1997 Cristian Gafton <gafton@redhat.com>
- added rootok and setproctitle patches
- updated pam config files for chfn and chsh

* Tue Sep 02 1997 Erik Troan <ewt@redhat.com>
- updated MCONFIG to automatically determine the architecture
- added glibc header hacks to fdisk code
- rdev is only available on the intel

* Fri Jul 18 1997 Erik Troan <ewt@redhat.com>
- update to util-linux 2.7, fixed login problems

* Wed Jun 25 1997 Erik Troan <ewt@redhat.com>
- Merged Red Hat changes into main util-linux source, updated package to
  development util-linux (nearly 2.7).

* Tue Apr 22 1997 Michael K. Johnson <johnsonm@redhat.com>
- LOG_AUTH --> LOG_AUTHPRIV in login and shutdown

* Mon Mar 03 1997 Michael K. Johnson <johnsonm@redhat.com>
- Moved to new pam and from pam.conf to pam.d

* Tue Feb 25 1997 Michael K. Johnson <johnsonm@redhat.com>
- pam.patch differentiated between different kinds of bad logins.
  In particular, "user does not exist" and "bad password" were treated
  differently.  This was a minor security hole.
